//Working 11/Nov/2016
//RAM chips located at 
#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266HTTPClient.h>

IPAddress ip(172, 16, 3, 4);
IPAddress dns(172, 16, 0, 1);
IPAddress gw(172, 16, 0, 1);
IPAddress mask(255, 255, 0, 0);

#define INT_PIN 14//;12
#define GPIO_IN ((volatile uint32_t*) 0x60000318)
//This declaration allows reading the individual Pins as a single port read. Faster.

//const char* ssid = "R2DLAN-ESS"; //SSID of the WiFi access point
//const char* pass = "test";
const char* ssid = "R2TXCAMP"; //Max 32 Chars
const char* pass = ""; //Max 64 chars

unsigned long previousMillis = 0;

volatile unsigned int score[500];  //buffer that quickly stores writes to high score memory
//Volatile keyword was very important.
//originally missing and wasted a great deal of time debugging strange behaviour.

byte score_index = 0;

char hiscore[12]; //The extracted and decoded High Score bytes


HTTPClient http;  //Initialise the Library

void read_score();  //Interrupt routine that quickly stores the data on the bus for later processing
void send_score();  //Sends the extracted and decoded score to the web server
void send_reset();  //Send "RESET" to the web server so event can be recorded.
int isReset();      //Routine that scans the buffer for a sequence of "00002 N.N"
int isHighScore();  //Routine that scans the buffer for a sequence of "AAA"


void setup(void)
{

  Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  //  WiFi.begin(ssid, password);
  Serial.println("");

  WiFi.config(ip, dns, gw, mask);
  WiFi.begin(ssid);//,pass);
  // Wait for connection
  while (WiFi.status() != WL_CONNECTED)
  {

    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());

  pinMode(INT_PIN, INPUT);
  pinMode(0, INPUT);
  pinMode(2, INPUT);
  pinMode(3, INPUT);
  pinMode(4, INPUT);
  pinMode(5, INPUT);
  pinMode(12, INPUT);
  pinMode(13, INPUT);
  pinMode(14, INPUT);
  pinMode(15, INPUT);
  pinMode(16, INPUT);
  //delay(9000);
  attachInterrupt(INT_PIN, read_score, CHANGE);//FALLING);

}

void loop()
{
  byte i;
  int indexer = 0;

  unsigned int k;
  int j;

  if (isReset())
  {
    Serial.print("score_index:"); Serial.println(score_index);
    score_index = 0;
    send_reset();
  }

  if (isHighScore()) //digitalRead(15))
  {

    Serial.print("score_index:"); Serial.println(score_index);
    delay(31000);
    if (score_index > 11)
    {
      i = 0;
      for (j = (score_index - 12); j < (score_index); j++)
      {

        // Converts Galaga Character Codes to ASCII
        //1D - D4
        //2D - D5
        //3D - D12
        //4D - D13
        //5D - D2
        //6D - D0
        hiscore[i] = 'd';
        k = 0b0011000000110101 & score[j];
        if ( k == 0x0000) hiscore[i] = '0';
        if ( k == 0x0010) hiscore[i] = '1';
        if ( k == 0x0001) hiscore[i] = '2';
        if ( k == 0x0011) hiscore[i] = '3';
        if ( k == 0x1000) hiscore[i] = '4';
        if ( k == 0x1001) hiscore[i] = '5';
        if ( k == 0x1001) hiscore[i] = '6';
        if ( k == 0x1011) hiscore[i] = '7';
        if ( k == 0x2000) hiscore[i] = '8';
        if ( k == 0x2010) hiscore[i] = '9';
        if ( k == 0x2001) hiscore[i] = 'A';
        if ( k == 0x2011) hiscore[i] = 'B';
        if ( k == 0x3000) hiscore[i] = 'C';
        if ( k == 0x3010) hiscore[i] = 'D';
        if ( k == 0x3001) hiscore[i] = 'E';
        if ( k == 0x3011) hiscore[i] = 'F';
        if ( k == 0x0004) hiscore[i] = 'G';
        if ( k == 0x0014) hiscore[i] = 'H';
        if ( k == 0x0005) hiscore[i] = 'I';
        if ( k == 0x0015) hiscore[i] = 'J';
        if ( k == 0x1004) hiscore[i] = 'K';
        if ( k == 0x1014) hiscore[i] = 'L';
        if ( k == 0x1005) hiscore[i] = 'M';
        if ( k == 0x1015) hiscore[i] = 'N';
        if ( k == 0x2004) hiscore[i] = 'O';
        if ( k == 0x2014) hiscore[i] = 'P';
        if ( k == 0x2005) hiscore[i] = 'Q';
        if ( k == 0x2015) hiscore[i] = 'R';
        if ( k == 0x3004) hiscore[i] = 'S';
        if ( k == 0x3014) hiscore[i] = 'T';
        if ( k == 0x3005) hiscore[i] = 'U';
        if ( k == 0x3015) hiscore[i] = 'V';
        if ( k == 0x0020) hiscore[i] = 'W';
        if ( k == 0x0030) hiscore[i] = 'X';
        if ( k == 0x0021) hiscore[i] = 'Y';
        if ( k == 0x0031) hiscore[i] = 'Z';
        if ( k == 0x1020) hiscore[i] = 'b'; //" "
        if ( k == 0x2021) hiscore[i] = 'c'; //"."
    
    
    
        Serial.print(j); Serial.print(":"); Serial.println(hiscore[i]);
        i++;
      }
    }
    score_index = 0;
    send_score();

  }
  unsigned long currentMillis = millis();
  if ((currentMillis - previousMillis) > 10000)
  {
    previousMillis = currentMillis;
    for (indexer = 0; indexer < 500; indexer++)
    {
      Serial.println(score[indexer]);
    }
  }

}


void send_score()
{
  Serial.println("[HTTP] begin...\n");
  String request =  String("/cgi-bin/galagaHS.pl?hs=") + hiscore;// + "&ini=" + initials;

  http.begin("172.16.0.20", 80, request ); //HTTP

  Serial.println("[HTTP] GET...\n");
  // start connection and send HTTP header
  int httpCode = http.GET();

  // httpCode will be negative on error
  if (httpCode > 0)
  {
    // HTTP header has been send and Server response header has been handled
    Serial.printf("[HTTP] GET... code: %d\n", httpCode);

    // file found at server
    if (httpCode == HTTP_CODE_OK)
    {
      String payload = http.getString();
      Serial.println(payload);
    }
    else
    {
      Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
    }
    http.end();
  }
}

void send_reset()
{
  Serial.println("\nPosting Reset");
  // return;

  Serial.println("[HTTP] begin...\n");
  String request =  String("/cgi-bin/galagaHS.pl?hs=RESET&ini=RESET");// + hiscore;// + "&ini=" + initials;

  http.begin("172.16.0.20", 80, request ); //HTTP

  Serial.println("[HTTP] GET...\n");
  // start connection and send HTTP header
  int httpCode = http.GET();

  // httpCode will be negative on error
  if (httpCode > 0)
  {
    // HTTP header has been send and Server response header has been handled
    Serial.printf("[HTTP] GET... code: %d\n", httpCode);

    // file found at server
    if (httpCode == HTTP_CODE_OK)
    {
      String payload = http.getString();
      Serial.println(payload);
    }
    else
    {
      Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
    }
    http.end();
  }
}

void read_score()
{
  score[score_index++] = (unsigned int) * GPIO_IN;

}

int isReset()
{
  //unsigned int pattern[9] = {0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x1001, 0x1034, 0x2021, 0x1034};
  unsigned int pattern[9] = {0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x1020, 0x1015, 0x2021, 0x1015};
  int i;
  int j;
  j = 0;
  for (i = 0; i < score_index; i++)
  {
    if ((score[i] & 0b0011000000110101) == pattern[j])
      //11100000000000010011000000111100
    {
      j++;
      if (j == 8)
      {
        Serial.println("\nReset DetectedReset DetectedReset DetectedReset DetectedReset Detected");
        return 8;
      }
    }
    else
    {
      j = 0;
    }
  }
  //Serial.print("jjjj:"); Serial.println(j, HEX);
  return 0;
}

int isHighScore()
{
  //#define plen 3
  unsigned int pattern[3] = {0x1020, 0x1020, 0x1020};
  int spos;
  int ppos;
  ppos = 0;
  for (spos = 0; spos < (score_index); spos++)
  {
    if ((score[spos] & 0b0011000000110101) == pattern[ppos])
    {
      ppos++;
      if (ppos == 3)
        return spos;
    }
    else
    {
      //spos -= ppos;
      ppos = 0;
    }
  }
  return 0;
}

// The following is a sample of the data that is sniffed during the bootup sequence of Galaga
// Futher down is sniffed data during high score entry
// 1. The large number eg is 3221291048 returned when reading from ESP8266 mem location 0x60000318.
// 2. This number contains the states of the 6 IO pins of interest. GPIO 13,12,5,4,2,0 
// 3. ANDing with mask 0b0011000000110101 returns only those GPIO of interest.
// 4. A basic lookup table in the form of if statements converts these values to characters 
//  
// 20000 N.N starts at 62
//  Index ((volatile uint32_t*) 0x60000318) Mask "0b0011000000110101" and DEC2BIN Decoded
//  0 3758190632  0020  2
//  1 3758174248  1000  4
//  2 3758178345  2010  9
//  3 3758166040  0034  J
//  4 3758186536  1031  #
//  5 3758166028  3020  E
//  6 3758186505  3020  E
//  7 3758161948  3020  E
//  8 3758178361  0021  Y
//  9 3758166056  1010  5
//  10  3758190600  2020  A
//  11  3758174216  1004  K
//  12  3758190600  2001  #
//  13  3758161933  0014  H
//  14  3758178329  0031  Z
//  15  3758161960  1020  6
//  16  3758186509  3000  C
//  17  3758161949  3000  C
//  18  3758178345  3000  C
//  19  3758166024  0005  #
//  20  3758186504  0011  X
//  21  3758161932  0020  2
//  22  3758178316  2005  #
//  23  3758161960  0015  #
//  24  3758182424  0021  Y
//  25  3758170152  1000  4
//  26  3758178317  2000  8
//  27  3758161929  0004  G
//  28  3758178312  0004  G
//  29  3758161944  0020  2
//  30  3758178344  1010  5
//  31  3758166040  2020  A
//  32  3758182424  0005  #
//  33  3758161960  0001  W
//  34  3758182424  0000  0
//  35  3758170168  0010  1
//  36  3758190617  0020  2
//  37  3758170172  1010  5
//  38  3758182461  1010  5
//  39  3758174265  0020  2
//  40  3758190636  1010  5
//  41  3758174237  2030  B
//  42  3758190601  3011  #
//  43  3758170140  2034  R
//  44  3758178365  1035  #
//  45  3758170156  3031  #
//  46  3758182413  3024  U
//  47  3758170121  3015  #
//  48  3758178332  3015  #
//  49  3758161961  3001  #
//  50  3758182408  2014  P
//  51  3758166024  0035  #
//  52  3758186553  2024  Q
//  53  3758166060  1005  #
//  54  3758190617  2001  #
//  55  3758161928  0014  H
//  56  3758178312  0021  Y
//  57  3758161928  1000  4
//  58  3758178312  1000  4
//  59  3758161960  2031  #
//  60  3758182409  1024  M
//  61  3758166076  3011  #
//  62  3758186537  0000  0
//  63  3758166076  0000  0
//  64  3758190632  0000  0
//  65  3758174236  0000  0
//  66  3758186557  0020  2
//  67  3758166061  1001  b
//  68  3758190617  1034  N
//  69  3758174233  2021  c
//  70  3758190617  1034  N
//  71  3758174233  3011  #
//  72  3758190636  3024  U
//  73  3758174237  3015  #
//  74  3758186557  2035  #
//  75  3758161961  0021  Y
//  76  3758182424  1010  5
//  77  3758170168  2030  B
//  78  3758182444  1024  M
//  79  3758174233  3011  #
//  80  3758186556  2034  R
//  81  3758161980  0034  J
//  82  3758182441  1021  #
//  83  3758174232  3010  D
//  84  3758178365  0035  #
//  85  3758166057  1021  #
//  86  3758190616  3010  D
//  87  3758170156  2024  Q
//  88  3758182429  1015  #
//  89  3758170169  2031  #
//  90  3758178313  2031  #
//  91  3758161944  0001  W
//  92  3758178344  0010  1
//  93  3758174249  0020  2
//  94  3758190604  3021  #
//  95  3758170125  3004  S
//  96  3758178333  2005  #
//  97  3758161961  0015  #
//  98  3758182424  0021  Y
//  99  3758166040  1010  5
//  100 3758182424  1010  5
//  101 3758166040  1010  5
//  102 3758186521  1010  5
//  103 3758161980  2011  #
//  104 3758182441  0034  J
//  105 3758161945  1021  #
//  106 3758178360  3000  C
//  107 3758166072  0011  X
//  108 3758190632  0030  3
//  109 3758174220  1030  7
//  110 3758186525  3020  E
//  111 3758174221  3004  S
//  112 3758186509  2015  #
//  113 3758161933  3005  #
//  114 3758178364  2005  #
//  115 3758166073  0005  #
//  116 3758190632  0034  J
//  117 3758174220  1031  #
//  118 3758186509  3020  E
//  119 3758161949  3004  S
//  120 3758178333  2005  #
//  121 3758174249  0015  #
//  122 3758190604  0015  #
//  123 3758170125  3021  #
//  124 3758178332  3004  S
//  125 3758161977  2005  #
//  126 3758182440  0014  H
//  127 3758174216  0031  Z
//  128 3758186508  1020  6
//  129 3758161949  3000  C
//  130 3758178333  2004  O
//  131 3758161949  0015  #
//  132 3758178333  0015  #
//  133 3758170169  2031  #
//  134 3758182444  1024  M
//  135 3758174217  3001  #
//  136 3758178344  0020  2
//  137 3758166040  1010  5
//  138 3758186552  2030  B
//  139 3758166060  1024  M
//  140 3758190601  3001  #
//  141 3758170124  2004  O
//  142 3758186508  2004  O
//  143 3758170120  2004  O
//  144 3758178332  2000  8
//  145 3758161961  0014  H
//  146 3758186505  0021  Y
//  147 3758161932  2001  #
//  148 3758178329  0004  G
//  149 3758161960  0011  X
//  150 3758182408  0020  2
//  151 3758170120  1000  4
//  152 3758186504  2000  8
//  153 3758170157  2000  8
//  154 3758182429  2000  8
//  155 3758170153  2000  8
//  156 3758178316  2025  #
//  157 3758161945  1015  #
//  158 3758178344  2021  c
//  159 3758166040  0004  G
//  160 3758186552  0011  X
//  161 3758166076  0020  2
//  162 3758178344  1010  5
//  163 3758166040  2030  B
//  164 3758186536  1034  N
//  165 3758166076  0020  2
//  166 3758190633  1010  5
//  167 3758174236  2020  A
//  168 3758186541  1034  N
//  169 3758166029  3021  #
//  170 3758186505  3014  T
//  171 3758161949  2025  #
//  172 3758178345  1005  #
//  173 3758166040  2001  #
//  174 3758178364  2001  #
//  175 3758166073  0015  #
//  176 3758190632  0021  Y
//  177 3758174236  1010  5
//  178 3758186541  0034  J
//  179 3758166029  1031  #
//  180 3758182413  3020  E
//  181 3758166029  3014  T
//  182 3758182413  2025  #
//  183 3758166029  1005  #
//  184 3758182413  1005  #
//  185 3758170137  1005  #
//  186 3758178364  1005  #
//  187 3758161980  1005  #
//  188 3758186536  1005  #
//  189 3758166028  2011  #
//  190 3758186521  0034  J
//  191 3758161964  3010  D
//  192 3758182425  2020  A
//  193 3758170152  1004  K
//  194 3758178365  2011  #
//  195 3758166057  0024  I
//  196 3758190616  1011  #
//  197 3758166028  2020  A
//  198 3758186521  0035  #
//  199 3758161980  1021  #
//  200 3758182457  3010  D
//  201 3758174264  1004  K
//  202 3758190636  2011  #
//  203 3758174252  0034  J
//  204 3758178364  1031  #
//  205 3758166057  3030  F
//  206 3758190616  3024  U
//  207 3758174252  3024  U
//  208 3758190605  0034  J
//  209 3758170141  1021  #
//  210 3758178349  3010  D
//  211 3758166041  3024  U
//  212 3758186552  3005  #
//  213 3758170168  2015  #
//  214 3758186552  0025  #
//  215 3758166060  1011  #
//  216 3758190601  2030  B
//  217 3758170124  2030  B
//  218 3758186508  2030  B
//  219 3758170124  2030  B
//  220 3758178316  1024  M
//  221 3758161945  3001  #
//  222 3758178360  2004  O
//  223 3758166056  0001  W
//  224 3758190616  0000  0
//  225 3758170156  0004  G
//  226 3758186540  0011  X
//  227 3758170172  0030  3
//  228 3758182461  1020  6
//  229 3758174249  3010  D
//  230 3758190616  2024  Q
//  231 3758170172  2024  Q
//  232 3758182445  2024  Q
//  233 3758174217  2034  R
//  234 3758186524  1035  #
//  235 3758161981  3021  #
//  236 3758178365  3010  D
//  237 3758161981  2034  R
//  238 3758178365  1025  #
//  239 3758174249  3001  #
//  240 3758190604  2014  P
//  241 3758170125  0035  #
//  242 3758186556  0035  #
//  243 3758166077  0035  #
//  244 3758190649  3021  #
//  245 3758174268  3004  S
//  246 3758190637  2005  #
//  247 3758174221  2034  R
//  248 3758190633  1035  #
//  249 3758174220  3031  #
//  250 3758186509  3034  V
//  251 3758161960  3025  #
//  252 3758182408  3005  #
//  253 3758170136  3021  #
//  254 3758178364  3004  S
//  255 3758166073  2005  #
//    0 #NUM! #NUM!
//  First High Score captured on the new PCB 58890 JPR
//  0 3758182409  1001  b
//  1 3758166040  1010  5
//  2 3758186504  2000  8
//  3 3758170120  2000  8
//  4 3758186520  2010  9
//  5 3758161928  0000  0
//  6 3758182409  1001  b
//  7 3758166025  1001  b
//  8 3758182409  1001  b
//  9 3758161980  0034  J
//  10  3758186524  2014  P
//  11  3758170172  2034  R
//  12  3758182408  1000  4
//  13  3758170120  2000  8
//  14  3758178316  0004  G
//  15  3758161932  0004  G
//  16  3758178344  0020  2
//  17  3758166040  1010  5
//  18  3758186536  2020  A
//  19  3758161933  0005  #
//  20  3758178313  0001  W

